#include <GL/glx.h>
#include "glfw_dyn.h"
#include <dlfcn.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void (*dyn_glXDestroyContext) (Display *dpy, GLXContext ctx) = 0;
int (*dyn_glXGetConfig) (Display *dpy, XVisualInfo *vis, int attrib, int *value) = 0;
void* (*dyn_glXGetProcAddress)(const GLubyte* procname) = 0;
GLXContext (*dyn_glXCreateContext) (Display *dpy, XVisualInfo *vis, GLXContext shareList, Bool direct) = 0;
Bool (*dyn_glXMakeCurrent) (Display *dpy, GLXDrawable drawable, GLXContext ctx) = 0;
Bool (*dyn_glXQueryExtension) (Display *dpy, int *errorBase, int *eventBase) = 0;
void (*dyn_glXSwapBuffers) (Display *dpy, GLXDrawable drawable) = 0;

static void* lib=0;
static char* libname=0;

int _glfwInitDyn()
{
    lib = dlopen(libname?libname:"libGL.so.1",RTLD_LAZY);
    if(lib == 0) return -1;
    dyn_glXDestroyContext=dlsym(lib,"glXDestroyContext");
    dyn_glXGetConfig=dlsym(lib,"glXGetConfig");
    dyn_glXCreateContext=dlsym(lib,"glXCreateContext");
    dyn_glXMakeCurrent=dlsym(lib,"glXMakeCurrent");
    dyn_glXQueryExtension=dlsym(lib,"glXQueryExtension");
    dyn_glXSwapBuffers=dlsym(lib,"glXSwapBuffers");
    dyn_glXGetProcAddress=dlsym(lib,"glXGetProcAddress");
    if(dyn_glXGetProcAddress==0) dyn_glXGetProcAddress=dlsym(lib,"glXGetProcAddressARB");
    return 1;
}

void _glfwSetGLlib(const char* l)
{
    if(libname) free(libname);
    libname=strdup(l);
}
