#include <SDL/SDL.h>
#include <caml/mlvalues.h>
#include <caml/alloc.h>
#include <caml/memory.h>
#include <caml/fail.h>

#include "shared.h"

void fail()
{
    failwith(SDL_GetError());
}

int ML_flags_to_mask(value flags, int flag_to_cvalue[])
{
    int i,n;
    int mask=0;
    CAMLparam0();
    while(Is_block(flags))
    {
	mask |= flag_to_cvalue[Int_val(Field(flags, 0))];
	flags=Field(flags, 1);
    }
    CAMLreturn(mask);
}

value carray_to_ML_list(int carray[], int arr_size)
{
    int i;
    CAMLparam0();
    CAMLlocal2(toreturn, tail);

    if(arr_size==0)
	CAMLreturn(Val_int(0));

    toreturn=alloc(2,0);
    Store_field(toreturn, 0, Val_int(carray[0]));
    tail=toreturn;
    for(i=1;i<arr_size;i++)
    {
        Field(tail,1) = alloc(2,0);
	tail=Field(tail,1);
        Store_field(tail, 0, Val_int(carray[i]));
    }
    Store_field(tail, 1, Val_int(0));
    CAMLreturn(toreturn);
}    

value mask_to_ML_flags(int mask, int flag_to_cvalue[], int arr_size)
{
#ifdef _WIN32
    int flagar[1024];
#else
    int flagar[arr_size];
#endif
    int n=0,i;
    CAMLparam0 ();

    for(i=0; i<arr_size; i++)
        if(mask&flag_to_cvalue[i])
	    flagar[n++]=i;

    CAMLreturn(carray_to_ML_list(flagar, n));    
}	    
