#include <SDL/SDL.h>
#include <caml/mlvalues.h>
#include <caml/alloc.h>
#include <caml/memory.h>

#include "shared.h"

static int flag_to_init[] = {
    0x00000001,
    0x00000010,
    0x00000020,
    0x00000100,
    0x00000200,
    0x00100000,
    0x01000000,
    0x0000FFFF
};

void MLSDL_init(value flags)
{
    CAMLparam1(flags);
    if(SDL_Init(ML_flags_to_mask(flags, flag_to_init)) == -1)
	fail();
    else CAMLreturn0;
}

void MLSDL_init_sub_system(value flags)
{
    CAMLparam1(flags);
    if(SDL_InitSubSystem(ML_flags_to_mask(flags, flag_to_init)) == -1)
	fail();
    
    CAMLreturn0;
}

void MLSDL_quit_sub_system(value flags)
{
    CAMLparam1 (flags);
    SDL_QuitSubSystem(ML_flags_to_mask(flags, flag_to_init));
    CAMLreturn0;
}

value MLSDL_was_init(value flags)
{	
    CAMLparam1 (flags);
    CAMLreturn (
	mask_to_ML_flags(
	    SDL_WasInit(ML_flags_to_mask(flags, flag_to_init)),
	    flag_to_init,8
	)
    );
}

void MLSDL_quit(value u)
{
    CAMLparam1 (u);
    SDL_Quit();
    CAMLreturn0;
}
